package mprj.doerj.caderno.util;

import com.liferay.portal.kernel.exception.SystemException;

import java.io.InputStream;
import java.math.BigInteger;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.GregorianCalendar;
import java.util.List;
import java.util.Locale;

import javax.portlet.ActionRequest;
import javax.portlet.PortletContext;
import javax.xml.bind.JAXBElement;
import javax.xml.bind.JAXBException;

import org.apache.commons.lang3.time.DateFormatUtils;
import org.docx4j.convert.in.xhtml.XHTMLImporterImpl;
import org.docx4j.openpackaging.exceptions.Docx4JException;
import org.docx4j.openpackaging.exceptions.InvalidFormatException;
import org.docx4j.openpackaging.packages.WordprocessingMLPackage;
import org.docx4j.openpackaging.parts.WordprocessingML.DocumentPart;
import org.docx4j.openpackaging.parts.WordprocessingML.MainDocumentPart;
import org.docx4j.openpackaging.parts.WordprocessingML.NumberingDefinitionsPart;
import org.docx4j.wml.BooleanDefaultTrue;
import org.docx4j.wml.ContentAccessor;
import org.docx4j.wml.P;
import org.docx4j.wml.PPr;
import org.docx4j.wml.PPrBase;
import org.docx4j.wml.PPrBase.NumPr;
import org.docx4j.wml.PPrBase.NumPr.Ilvl;
import org.docx4j.wml.PPrBase.NumPr.NumId;
import org.docx4j.wml.R;
import org.docx4j.wml.RPr;
import org.docx4j.wml.Text;
import org.json.JSONArray;
import org.json.JSONObject;

import mprj.doerj.caderno.application.model.Lista;


public class CadernoUtil {
	
	public static String ORGAO="";
	public static String TITULO="";
	public static Long QTD_LISTAS=0L;

	public static String getDatasCadastradas() throws SystemException, ParseException{
		String  datas = " ";
		Date data = GregorianCalendar.getInstance().getTime();
		String now = DateFormatUtils.format(GregorianCalendar.getInstance(), "dd/MM/yyyy", new Locale("pt-BR"));
		boolean ch=false;
		datas+=  datas.substring(0, datas.length() - 1);
		datas += " ";
		return datas;
	}
	
	public static String tratarString(String textoHtml,String tipo){
		
		
		try{
		
		if(tipo.equals("conteudo")||tipo.equals("conteudoPrimeiraPagina")){
			
			textoHtml = tratarTagsHtml(textoHtml,"p","manterTags");
			textoHtml = tratarTagsHtml(textoHtml,"o:p","manterTags");
			textoHtml = tratarTagsHtml(textoHtml,"b","manterTags");
			textoHtml = tratarTagsHtml(textoHtml,"u","manterTags");
			textoHtml = tratarTagsHtml(textoHtml,"span","manterTags");
			textoHtml = tratarTagsHtml(textoHtml,"font","manterTags");
			textoHtml = tratarTagsHtml(textoHtml,"div","manterTags");
			textoHtml = tratarTagsHtml(textoHtml,"sup","manterTags");
			textoHtml = tratarTagsHtml(textoHtml,"blockquote","manterTags");
			textoHtml = tratarTagsHtml(textoHtml,"ol","manterTags");
			textoHtml = tratarTagsHtml(textoHtml,"ul","manterTags");
			textoHtml = tratarTagsHtml(textoHtml,"li","manterTags");
			
		textoHtml = textoHtml.replaceAll("<p>&nbsp;</p>", "");
		textoHtml = textoHtml.replaceAll("<p></p>", "");
		textoHtml = textoHtml.replaceAll("data:image=&quot;&quot;", "");
		textoHtml = textoHtml.replaceAll("\"", "");
		textoHtml = textoHtml.replaceAll("&ndash;", "-");
		textoHtml = textoHtml.replaceAll("&nbsp;", " ");
		textoHtml = textoHtml.replaceAll("&quot;", "'");
		textoHtml = textoHtml.replaceAll("<h1>", "<p>");
		textoHtml = textoHtml.replaceAll("</h1>", "</p>");
		textoHtml = textoHtml.replaceAll("<h2>", "<p>");
		textoHtml = textoHtml.replaceAll("</h2>", "</p>");
		textoHtml = textoHtml.replaceAll("<h3>", "<p>");
		textoHtml = textoHtml.replaceAll("</h3>", "</p>");
		textoHtml = textoHtml.replaceAll("<h4>", "<p>");
		textoHtml = textoHtml.replaceAll("</h4>", "</p>");
		textoHtml = textoHtml.replaceAll("<h5>", "<p>");
		textoHtml = textoHtml.replaceAll("</h5>", "</p>");
		textoHtml = textoHtml.replaceAll("<h6>", "<p>");
		textoHtml = textoHtml.replaceAll("</h6>", "</p>");
		textoHtml = textoHtml.replaceAll("<div>", "");
		textoHtml = textoHtml.replaceAll("</div>", "");
		textoHtml = textoHtml.replaceAll("\n", "");
		textoHtml = textoHtml.replaceAll("\r", "");
		
		textoHtml = textoHtml.replaceAll("o:p", "p");
		
		textoHtml = textoHtml.replace("&nspace;"," ");
		textoHtml = textoHtml.replace("&nspace2;"," ");
		textoHtml = textoHtml.replace("&ndash2;","-");
		textoHtml = textoHtml.replace("&ndash3;","˜");
		textoHtml = textoHtml.replace("&ndash4;","™");
		textoHtml = textoHtml.replace("&ndash5;","š");
		textoHtml = textoHtml.replace("&ndash6;","›");
		textoHtml = textoHtml.replace("&ndash7;","œ");
		textoHtml = textoHtml.replace("&ndash8;","ž");
		textoHtml = textoHtml.replace("&ndash9;","Ÿ");
		textoHtml = textoHtml.replace("&ndash10;","-");
		textoHtml = textoHtml.replace("&ndash11;","-");
		textoHtml = textoHtml.replace("&ndash12;","-");
		textoHtml = textoHtml.replace("&ndash13;","'");
		textoHtml = textoHtml.replace("&ndash14;","'");
		
		
		String primeirosChar="";
		
		primeirosChar = textoHtml.substring(0, 3);
		
			if (!primeirosChar.equals("<p>")&& !tipo.equals("conteudoPrimeiraPagina")){
				//textoHtml = "<p align='JUSTIFY'>" + textoHtml + "</p>";
				textoHtml = "<p>" + textoHtml + "</p>";
				
			}
		
			if(tipo.equals("conteudo")){
			textoHtml = "<body><head><style type='" + "text/css'" + ">p{font-family:Spranq eco sans;font-size:12px;text-align:justify;margin-left:-8px;margin-top:0px;margin-bottom:0px;} ul {list-style-type: circle;} </style></head>" + textoHtml + "</body>";
		
			}
		}
		
		if (tipo.equals("titulo")){
			
			textoHtml =textoHtml.toUpperCase(); 
			
			if (textoHtml==null || textoHtml.equals("0")){
				textoHtml="";
			}
			
			
		}
		}catch(Exception e){
			e.printStackTrace();
			
		}
		
		return textoHtml;
		
	}

	public static String tratarTagsHtml(String conteudoHtml, String tag,String acao){
		
		String tagAberta="";
		String tagFechada="";
		int tamanhoTag=0;
		
		if (tag.equals("p")){
			
			tagAberta="<p ";
			tagFechada="<p>";
			tamanhoTag=3;
			
		}
		
		if (tag.equals("b")){
			
			tagAberta="<b ";
			tagFechada="<b>";
			tamanhoTag=3;
			
		}
		
		
		if (tag.equals("u")){
			
			tagAberta="<u ";
			tagFechada="<u>";
			tamanhoTag=3;
			
		}
		
	if (tag.equals("a")){
			
			tagAberta="<a ";
			tagFechada="<a>";
			tamanhoTag=3;
			
		}
		
		if (tag.equals("div")){
			
			tagAberta="<div ";
			tagFechada="<div>";
			tamanhoTag=5;
			
		}
		
		if (tag.equals("sup")){
			
			tagAberta="<sup ";
			tagFechada="<sup>";
			tamanhoTag=5;
			
		}
		
		if (tag.equals("span")){
			
			tagAberta="<span ";
			tagFechada="<span>";
			tamanhoTag=6;
			
		}
		
		if (tag.equals("font")){
			
			tagAberta="<font ";
			tagFechada="<font>";
			tamanhoTag=6;
			
		}
		
		if (tag.equals("blockquote")){
			
			tagAberta="<blockquote ";
			tagFechada="<blockquote>";
			tamanhoTag=12;
			
		}
		
		if (tag.equals("ol")){
			
			tagAberta="<ol ";
			tagFechada="<ol>";
			tamanhoTag=4;
			
		}
		
		if (tag.equals("ul")){
			
			tagAberta="<ul ";
			tagFechada="<ul>";
			tamanhoTag=4;
			
		}
		
		if (tag.equals("li")){
			
			tagAberta="<li ";
			tagFechada="<li>";
			tamanhoTag=4;
			
		}
		
		if (tag.equals("o:p")){
			
			tagAberta="<o:p>";
			tagFechada="<o:p>";
			tamanhoTag=5;
			
		}
		
		int len = conteudoHtml.length();
		   String tagP = "";

		    for (int i=0;i<len;i++)
		    {
		    	
		    	if(i+tamanhoTag<len){
		    		tagP = conteudoHtml.substring(i, i+tamanhoTag);
		    		
		    	}else{
		    		tagP = conteudoHtml.substring(i, len);
		    		
		    	}
		        String caracterCorrente="";
		        String strAcumulado="";
		        int indiceInicio = i;
		        if (tagP.equals(tagAberta)){
		        	int indiceFim=indiceInicio+1;
		        	
		        	while (!caracterCorrente.equals(">")){
		        		
		        		strAcumulado = conteudoHtml.substring(indiceInicio,indiceFim);
		        		caracterCorrente = conteudoHtml.substring(indiceFim-1,indiceFim);
		        		indiceFim++;
		        		
		        	}
		        	
		        	if (tag.equals("span")){
		        		conteudoHtml = conteudoHtml.replace(strAcumulado, "");
		        		conteudoHtml = conteudoHtml.replaceAll("</span>", "");
		        		conteudoHtml = conteudoHtml.replaceAll("<span>", "");
		        		i=0;
		        	}else if (tag.equals("font")){
		        		conteudoHtml = conteudoHtml.replace(strAcumulado, "");
		        		conteudoHtml = conteudoHtml.replaceAll("</font>", "");
		        		conteudoHtml = conteudoHtml.replaceAll("<font>", "");
		        		i=0;
		        		
		        	}else if (tag.equals("div")){
		        		conteudoHtml = conteudoHtml.replace(strAcumulado, "");
		        		conteudoHtml = conteudoHtml.replaceAll("</div>", "");
		        		conteudoHtml = conteudoHtml.replaceAll("<div>", "");
		        		i=0;
		        		
		        	}else if (tag.equals("sup")){
		        		conteudoHtml = conteudoHtml.replace(strAcumulado, "");
		        		conteudoHtml = conteudoHtml.replaceAll("</sup>", "");
		        		conteudoHtml = conteudoHtml.replaceAll("<sup>", "");
		        		i=0;	
		        	}else if (tag.equals("o:p")){
		        		conteudoHtml = conteudoHtml.replace(strAcumulado, "");
		        		conteudoHtml = conteudoHtml.replaceAll("</o:p>", "");
		        		conteudoHtml = conteudoHtml.replaceAll("<o:p>", "");
		        		i=0;	
		        	}else if (tag.equals("ol")){
		        		
		        			if(strAcumulado.contains("alpha")) {
		        				
		        				conteudoHtml = conteudoHtml.replace(strAcumulado, "<o1>");
				        		i=0;
		        			}else {
		        				
		        				conteudoHtml = conteudoHtml.replace(strAcumulado, tagFechada);
		        			}
		        		
		        			
		        	}else if (tag.equals("a")){	
		        		
		        		if(acao.equals("excluirTags")){
		        			conteudoHtml = conteudoHtml.replace(strAcumulado, "");
			        		conteudoHtml = conteudoHtml.replaceAll("</a>", "");
			        		conteudoHtml = conteudoHtml.replaceAll("<a>", "");
			        		i=0;
		        		}
		        		
		        		
		        	}else{
		        		
		        		if(acao.equals("manterTags")){
		        			conteudoHtml = conteudoHtml.replace(strAcumulado, tagFechada);
		        			
		        		}else{
		        			conteudoHtml = conteudoHtml.replace(strAcumulado, "");
		        		}
		        		i=0;
		        	}
		        	
		        	len = conteudoHtml.length();
		        	
		        }
		    	
		    }
		
		
		return conteudoHtml;
	} 
	public WordprocessingMLPackage ConverterHTML(String stringFromFile,String orgao,String titulo, String idMateria,String delimitador,ActionRequest actionRequest) throws Docx4JException{
		
		PortletContext context = actionRequest.getPortletSession().getPortletContext();
		String baseURL = "file:///" + getClass().getResourceAsStream("/META-INF/resources/template");
		String unescaped = stringFromFile;
      InputStream templateEstilos = getClass().getResourceAsStream("/META-INF/resources/template/TemplateEstilos.docx");
      WordprocessingMLPackage templatePackageEstilos = WordprocessingMLPackage.load(templateEstilos);
      // Create an empty docx package
      WordprocessingMLPackage wordMLPackage = templatePackageEstilos;
		try {
		MainDocumentPart DocumentPart = wordMLPackage.getMainDocumentPart();
		
		String marcadorMateriaInicio = "##MATERIA##INICIO##ID: " + idMateria;
		String marcadorMateriaFim = "##MATERIA##FIM##ID: " + idMateria;
		
		if(delimitador.equals("on")) {
		DocumentPart.addStyledParagraphOfText("MarcadorMateria",marcadorMateriaInicio);
		}
		
		if(!orgao.equals(ORGAO)){
			DocumentPart.addStyledParagraphOfText("TituloDoeMPRJ",orgao);
			ORGAO=orgao;
			
			DocumentPart.addStyledParagraphOfText("SubtituloDOe-MPRJ",titulo);
			TITULO=titulo;
		}
			
		if(!titulo.equals(TITULO) && orgao.equals(ORGAO)){
			
			DocumentPart.addStyledParagraphOfText("SubtituloDOe-MPRJ",titulo);
			TITULO=titulo;
		}
					
		// Convert the XHTML, and add it into the empty docx we made
      XHTMLImporterImpl XHTMLImporter = new XHTMLImporterImpl(wordMLPackage);
      
      
      XHTMLImporter.setHyperlinkStyle("Hyperlink");
      wordMLPackage.getMainDocumentPart().getContent().addAll(XHTMLImporter.convert(unescaped, baseURL) );
	      
	      if(delimitador.equals("on")) {
			DocumentPart.addStyledParagraphOfText("MarcadorMateria",marcadorMateriaFim);
	      }
		//System.out.println(	XmlUtils.marshaltoString(wordMLPackage.getMainDocumentPart().getJaxbElement(), true, true));
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
		wordMLPackage = removerParagrafosVazios(wordMLPackage);
    return wordMLPackage;
}
	
	
public static String gerarDataCabecalho(String data) throws ParseException{
	
	String resultado="";
	
	String diaSemanaStr="";
	String dia=data.substring(0,2);
	String mes = data.substring(3, 5);
	String ano = data.substring(6, 10);
	String mesStr="";
	
	SimpleDateFormat sdf = new SimpleDateFormat("dd/MM/yyyy");
    Date dataConverter = sdf.parse(data);
    GregorianCalendar gc = new GregorianCalendar();
    gc.setTime(dataConverter);
    int diaSemana = gc.get(GregorianCalendar.DAY_OF_WEEK);
    
    if(dia.substring(0, 1).equals("0")) {
    	dia=dia.substring(1, 2);
    	
    }
    
    if (diaSemana == 1){
    	diaSemanaStr = "Domingo";
    }

    if (diaSemana == 2){
    	diaSemanaStr = "Segunda-feira";
    }
    
    if (diaSemana == 3){
    	diaSemanaStr = "Ter\u00E7a-feira";
    }

    
    if (diaSemana == 4){
    	diaSemanaStr = "Quarta-feira";
    }

    
    if (diaSemana == 5){
    	diaSemanaStr = "Quinta-feira";
    }

    
    if (diaSemana == 6){
    	diaSemanaStr = "Sexta-feira";
    }

    
    if (diaSemana == 7){
    	diaSemanaStr = "S\u00e1bado";
    }


    if(mes.equals("01")){
    	mesStr="janeiro";
    	
    }
    
    if(mes.equals("02")){
    	mesStr="fevereiro";
    	
    }
    
    if(mes.equals("03")){
    	mesStr="mar\u00E7o";
    	
    }
    
    if(mes.equals("04")){
    	mesStr="abril";
    	
    }
    
    if(mes.equals("05")){
    	mesStr="maio";
    	
    }
    
    if(mes.equals("06")){
    	mesStr="junho";
    	
    }
    
    if(mes.equals("07")){
    	mesStr="julho";
    	
    }
    
    if(mes.equals("08")){
    	mesStr="agosto";
    	
    }
    
    if(mes.equals("09")){
    	mesStr="setembro";
    	
    }
    
    if(mes.equals("10")){
    	mesStr="outubro";
    	
    }
    
    if(mes.equals("11")){
    	mesStr="novembro";
    	
    }
    
    if(mes.equals("12")){
    	mesStr="dezembro";
    	
    }
	
    resultado=diaSemanaStr + " | " + dia + " de " + mesStr + " de " + ano; 
	
	return resultado;
}

public static List<Object> getAllElementFromObject(Object obj, Class<?> toSearch) {
    List<Object> result = new ArrayList<Object>();
    if (obj instanceof JAXBElement) obj = ((JAXBElement<?>) obj).getValue();

    if (obj.getClass().equals(toSearch))
        result.add(obj);
    else if (obj instanceof ContentAccessor) {
        List<?> children = ((ContentAccessor) obj).getContent();
        for (Object child : children) {
            result.addAll(getAllElementFromObject(child, toSearch));
        }
    }
    return result;
}

public static WordprocessingMLPackage formatarListas(WordprocessingMLPackage wordPackage,List<Lista>listaUl) throws InvalidFormatException, JAXBException {
	
	DocumentPart parte = wordPackage.getMainDocumentPart();
	
	Long indiceLista=0L;
	Boolean eLista = false;
	Boolean itemAnterior=false;
	Boolean formatar;
	Long numero=0L;
	CadernoUtil caderno = new CadernoUtil();
	List<Object> paragraphs = getAllElementFromObject(parte,P.class);
	 for(Object par : paragraphs){
		 System.out.println(numero);
	        P p = (P) par;
	        List<Object> Rs = getAllElementFromObject(p, R.class);
	        for(Object r : Rs){
	            R objetoR = (R)r;
	            List<Object> Rs2 = getAllElementFromObject(objetoR, R.class);
	            
	            for(Object r2:Rs2) {
	            	
	            	R objetoR2 = (R)r2;
	            	Object objetoParent = objetoR2.getParent();
	            	if (objetoR2.getParent() instanceof P) {
			            	P parent = (P) objetoParent;
			            	PPr ppr = parent.getPPr();
			            	
			            	
			            	NumPr numPr = ppr.getNumPr();
			            	
				            	if(numPr!=null) {
				            	eLista=true;	
				            	
				            	indiceLista++;
				            	
				            	formatar=false;
				            	Long ilvlValor=0L;
				            		for(int i=0;i<listaUl.size();i++) {
				            			if(indiceLista==listaUl.get(i).getPosicaoOl()) {
				            				formatar=true;
				            				Lista itemLista = listaUl.get(i);
				            				ilvlValor = itemLista.getIlvl();
				            			}
				            		}
				            		
				            		if(formatar==true) {
			            				Ilvl ilvl = numPr.getIlvl();
						            	ilvl.setVal(BigInteger.valueOf(ilvlValor));
						            	numPr.setIlvl(ilvl);
						            	
						            	NumberingDefinitionsPart ndp = new NumberingDefinitionsPart();
						            	wordPackage.getMainDocumentPart().addTargetPart(ndp);
						            	
						            	NumId numId = numPr.getNumId();
						            	numId.setVal(BigInteger.ZERO);
						            	numPr.setNumId(numId);
			            			}else {
			            				
			            				org.docx4j.wml.ObjectFactory wmlObjectFactory = new org.docx4j.wml.ObjectFactory();
			            				PPrBase.PStyle pprBaseStyle = wmlObjectFactory.createPPrBasePStyle();
			            				
			            				Ilvl ilvl = numPr.getIlvl();
						            	ilvl.setVal(BigInteger.ZERO);

						            	NumId numId = numPr.getNumId();
						            	numId.setVal(BigInteger.ZERO);
						            	ppr.setPStyle(pprBaseStyle);
						            	pprBaseStyle.setVal("marcadorBullet");
			            				
			            			}
					            		
			            	}else {
			            		eLista=false;
			            	}
	            	}
	            }
	        }
	        itemAnterior = eLista;
	        numero++;
	    }
	
	return wordPackage;
}

public static List<Lista> retornarOls(String conteudoHtml){
	
		List<Lista> listaOls = new ArrayList<Lista>();
		Boolean tagOl=false;
		Boolean primeiroItem = true;
		Long qtdListasAbertas=0L;
		

		String tagAberta = "";
		String tagFechada = "";
		int tamanhoTag = 0;

		tamanhoTag = 4;

		int len = conteudoHtml.length();
		String tagP = "";

		for (int i = 0; i < len; i++) {

			if (i + tamanhoTag < len) {
				tagP = conteudoHtml.substring(i, i + tamanhoTag);

			} else {
				tagP = conteudoHtml.substring(i, len);

			}
			
			
			if (tagP.equals("<ol>")|| tagP.equals("<ul>") ) {
				
				if(primeiroItem==true) {
				primeiroItem=false;	
				}else {
				qtdListasAbertas++;
				}
				
				if (tagP.equals("<ol>")) {
					tagOl=true;
				}else {
					tagOl=false;
				}
				
			}
			
			if (tagP.equals("</ol") || tagP.equals("</ul")) {
				qtdListasAbertas--;	
			}
			
			if (tagP.equals("<li>")) {
			QTD_LISTAS++;
				
				if (tagP.equals("<li>") && tagOl==true) {
				
				//posicaoItemOl=QTD_LISTAS;
					
				Lista lista = new Lista();
				lista.setPosicaoOl(QTD_LISTAS);
				lista.setIlvl(qtdListasAbertas);
					
					listaOls.add(lista);
					
				}
				

			}

		}
	
	return listaOls;
}


public static String tratarLista(String conteudoHtml){
	
	List<Integer> listaOls = new ArrayList<Integer>();
	int indiceListaAtual=-1;
	Boolean tagOl=false;
	Boolean tagO1=false;
	int margem=0;
	int item=0;
	int tamanhoTag = 0;
	String marcador="";
	String newTagP="";
	String espacos="\u202F\u202F";
	char alpha='a';
	
	tamanhoTag = 4;

	int len = conteudoHtml.length();
	String tagP = "";

	for (int i = 0; i < len; i++) {

		if (i + tamanhoTag < len) {
			tagP = conteudoHtml.substring(i, i + tamanhoTag);

		} else {
			tagP = conteudoHtml.substring(i, len);

		}
		
		
		if (tagP.equals("<ol>")|| tagP.equals("<ul>") ||  tagP.equals("<o1>")) {
			
					
			if (tagP.equals("<ol>")) {
				tagOl=true;
				tagO1=false;
				item=1;
				indiceListaAtual++;
				listaOls.add(item);
				
				
			}
			
			if (tagP.equals("<o1>")) {
				tagOl=false;
				tagO1=true;
			}
			
			if (tagP.equals("<ul>")) {
				tagOl=false;
				tagO1=false;
			}
			
		}
		
		
		if (tagP.equals("<li>")) {
			
			if (tagP.equals("<li>")) {
			
				if (tagOl==true) {
					
					
					margem=(indiceListaAtual)*20;
					newTagP = "<p style='margin-left:"+margem+"px'>";

					if (item<=9) {
						marcador = newTagP+String.valueOf(listaOls.get(indiceListaAtual))+"."+espacos;
					}else {
						marcador = newTagP+String.valueOf(listaOls.get(indiceListaAtual))+"."+espacos;
					}
					
					item=listaOls.get(indiceListaAtual)+1;
					listaOls.set(indiceListaAtual, item);
					conteudoHtml = conteudoHtml.substring(0,i ) + marcador + conteudoHtml.substring(i + tamanhoTag,conteudoHtml.length());
					len = conteudoHtml.length();
				}
				
				if (tagO1==true) {
					newTagP = "<p style='margin-left:0px'>";
					marcador = newTagP+alpha + espacos;
					conteudoHtml = conteudoHtml.substring(0,i) + marcador + conteudoHtml.substring(i + tamanhoTag,conteudoHtml.length());
					alpha++;
					len = conteudoHtml.length();
					
				}
				
				if (tagOl==false && tagO1==false) {
					newTagP = "<p style='margin-left:0px'>";
					marcador = newTagP+espacos;
					conteudoHtml = conteudoHtml.substring(0,i ) + marcador + conteudoHtml.substring(i + tamanhoTag,conteudoHtml.length());
					len = conteudoHtml.length();
				}
				
				len = conteudoHtml.length();
			}
			

		}
		
		if (tagP.equals("</ol")) {
			indiceListaAtual--;
			
		}
		

	}
	conteudoHtml = conteudoHtml.replaceAll("<ol>", "<p>");
	conteudoHtml = conteudoHtml.replaceAll("<o1>", "<p>");
	conteudoHtml = conteudoHtml.replaceAll("<ul>", "<p>");
	conteudoHtml = conteudoHtml.replaceAll("<li>", "<p>");
	conteudoHtml = conteudoHtml.replaceAll("</li>", "</p>");
	conteudoHtml = conteudoHtml.replaceAll("</ol>", "</p>");
	conteudoHtml = conteudoHtml.replaceAll("</ul>", "</p>");

return conteudoHtml;
}

public String trataNome(JSONArray listaConteudos,String titulo) {
	
	String tituloTratado="";
	Long contador=0L;
	int  indiceItem=0;
	
	
	for(int i=0;i<listaConteudos.length();i++){
		
		JSONObject obj = new JSONObject(listaConteudos.get(i).toString());
		tituloTratado = obj.get("NOME").toString();
		
		if(titulo.equals(tituloTratado)) {
			contador++;
			indiceItem=i;
		}
	}
	
	if (contador>1) {
		JSONObject obj = new JSONObject(listaConteudos.get(indiceItem).toString());
		tituloTratado = obj.get("NOMEPLURAL").toString();
		
	}else {
		JSONObject obj = new JSONObject(listaConteudos.get(indiceItem).toString());
		tituloTratado = obj.get("NOME").toString();
	}
	
	return tituloTratado;
	
}


	public WordprocessingMLPackage removerParagrafosVazios(WordprocessingMLPackage wordPackage) {

		DocumentPart parte = wordPackage.getMainDocumentPart();

		List<Object> paragraphs = getAllElementFromObject(parte, P.class);
		for (Object par : paragraphs) {
			P p = (P) par;
			List<Object> listaP = p.getContent();
			if (listaP.size() == 0) {
				wordPackage.getMainDocumentPart().getContent().remove(p);
			}
		}

		return wordPackage;
	}

	public WordprocessingMLPackage tratarExpedienteVago(WordprocessingMLPackage wordPackage) {
		
		DocumentPart parte = wordPackage.getMainDocumentPart();

		List<Object> paragraphs = getAllElementFromObject(parte, P.class);
		for (Object par : paragraphs) {
			P p = (P) par;
			List<Object> listaP = p.getContent();
			if (listaP.size() > 0) {
				for (Object obj : listaP) {
					R r = (R)obj;
					List<Object> listaR = r.getContent();
					if (listaR.size() > 0) {
						for (Object objR : listaR) {
							
							JAXBElement jaxb = (JAXBElement)objR;
							Object textoValue = jaxb.getValue();
							Text texto = (Text)textoValue;
							String textoStr=texto.getValue().toString();
							
							if (textoStr.equals("(Vago)") || textoStr.equals("Vago")) {
								
								Object objR2 = texto.getParent();
								R r2 = (R)objR2;
								RPr rpr=null;
								if(r2.getRPr()==null) {
									rpr = new RPr();
								}else {
									
									rpr = r2.getRPr();
								}
								BooleanDefaultTrue italico = new BooleanDefaultTrue();
								italico.setVal(true);
								rpr.setI(italico);
								r2.setRPr(rpr);
								
							}
							
						}
						
						
					}
					
					
				}
				
			}
			
			
		}
		return wordPackage;
	}

}
