package mprj.doerj.caderno.util;

import com.liferay.portal.kernel.exception.PortalException;
import com.liferay.portal.kernel.theme.ThemeDisplay;
import com.liferay.portal.kernel.util.ContentTypes;
import com.liferay.portal.kernel.util.PortalUtil;
import com.liferay.portal.kernel.util.WebKeys;

import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.text.ParseException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;

import javax.portlet.ActionRequest;
import javax.portlet.ActionResponse;
import javax.portlet.PortletContext;
import javax.portlet.PortletPreferences;
import javax.portlet.PortletResponse;
import javax.servlet.http.HttpServletResponse;
import javax.xml.bind.JAXBContext;
import javax.xml.bind.JAXBException;

import org.docx4j.XmlUtils;
import org.docx4j.convert.in.xhtml.FormattingOption;
import org.docx4j.convert.in.xhtml.XHTMLImporterImpl;
import org.docx4j.openpackaging.exceptions.Docx4JException;
import org.docx4j.openpackaging.packages.WordprocessingMLPackage;
import org.docx4j.openpackaging.parts.WordprocessingML.HeaderPart;
import org.docx4j.openpackaging.parts.WordprocessingML.MainDocumentPart;
import org.docx4j.openpackaging.parts.WordprocessingML.NumberingDefinitionsPart;
import org.json.JSONArray;
import org.json.JSONObject;

import mprj.doerj.caderno.application.model.Lista;

public class GeraCaderno {

	public void processaCaderno(ActionRequest actionRequest, ActionResponse actionResponse, JSONArray listaConteudos,
			String dataDivulgacao, String delimitador)
			throws Docx4JException, JAXBException, IOException, ParseException, PortalException {
		PortletContext context = actionRequest.getPortletSession().getPortletContext();

		InputStream templateCaderno = getClass()
				.getResourceAsStream("/META-INF/resources/template/TemplateCaderno.docx");
		ThemeDisplay themeDisplay = (ThemeDisplay) actionRequest.getAttribute(WebKeys.THEME_DISPLAY);

		String conteudo = "";
		String orgao = "";
		String titulo = "";
		String idMateria = "";
		Boolean expedienteVago = false;
		PortletPreferences prefs = actionRequest.getPreferences();
		CadernoUtil util = new CadernoUtil();
		MainDocumentPart currentDocumentPart = null;

		System.out.println("Iniciando teste do JAXBContext...");
		JAXBContext.newInstance("org.docx4j.openpackaging.contenttype");
		System.out.println("Finalizado teste do JAXBContext.");

		WordprocessingMLPackage templatePackage = WordprocessingMLPackage.load(templateCaderno);

		// System.out.println(XmlUtils.marshaltoString(templatePackage.getMainDocumentPart().getJaxbElement(),
		// true, true));
		WordprocessingMLPackage acumuladoPackage = WordprocessingMLPackage.createPackage();

//Preenche os dados do cabealho

		MainDocumentPart headerDocumentPart = templatePackage.getMainDocumentPart();

		MainDocumentPart mainPart = templatePackage.getMainDocumentPart();
		HeaderPart headerPart = templatePackage.getHeaderFooterPolicy().getDefaultHeader();
		HeaderPart firstPageHeaderPart = templatePackage.getHeaderFooterPolicy().getFirstHeader();

		JSONObject cabecalho = new JSONObject(listaConteudos.getJSONObject(0).toString());

		String edicao = "--";
		String disponibilizacao = util.gerarDataCabecalho(dataDivulgacao);
		String publicacao = "--";

//Cria o hash map com as variveis para substuio dos dados dos cabealhos e expediente		    
		HashMap<String, String> variables = new HashMap<String, String>();
		variables.put("edi", edicao);
		variables.put("dis", disponibilizacao);
		variables.put("pub", publicacao);

		String PGJ = prefs.getValue("PGJConfig", "");
		variables.put("PGJ", PGJ);

		if (PGJ.equals("(Vago)") || PGJ.equals("Vago")) {
			expedienteVago = true;
		}

		String CGMP = prefs.getValue("CGMPConfig", "");
		variables.put("CGMP", CGMP);

		if (CGMP.equals("(Vago)") || CGMP.equals("Vago")) {
			expedienteVago = true;
		}

		String SGJA = prefs.getValue("SGJAConfig", "");
		variables.put("SGJA", SGJA);

		if (SGJA.equals("(Vago)") || SGJA.equals("Vago")) {
			expedienteVago = true;
		}

		String SGJPI = prefs.getValue("SGJPIConfig", "");
		variables.put("SGJPI", SGJPI);

		if (SGJPI.equals("(Vago)") || SGJPI.equals("Vago")) {
			expedienteVago = true;
		}

		String SGJACI = prefs.getValue("SGJACIConfig", "");
		variables.put("SGJACI", SGJACI);

		if (SGJACI.equals("(Vago)") || SGJACI.equals("Vago")) {
			expedienteVago = true;
		}

		String SGJACDH = prefs.getValue("SGJACDHConfig", "");
		variables.put("SGJACDH", SGJACDH);

		if (SGJACDH.equals("(Vago)") || SGJACDH.equals("Vago")) {
			expedienteVago = true;
		}

		String SGJRIDP = prefs.getValue("SGJRIDPConfig", "");
		variables.put("SGJRIDP", SGJRIDP);

		if (SGJRIDP.equals("(Vago)") || SGJRIDP.equals("Vago")) {
			expedienteVago = true;
		}

		String CG = prefs.getValue("CGConfig", "");
		variables.put("CG", CG);

		if (CG.equals("(Vago)") || CG.equals("Vago")) {
			expedienteVago = true;
		}

		String CJ = prefs.getValue("CJConfig", "");
		variables.put("CJ", CJ);

		if (CJ.equals("(Vago)") || CJ.equals("Vago")) {
			expedienteVago = true;
		}

		String AE = prefs.getValue("AEConfig", "");
		variables.put("AE", AE);

		if (AE.equals("(Vago)") || AE.equals("Vago")) {
			expedienteVago = true;
		}

		String CMPROCJ = prefs.getValue("CMPROCJConfig", "");
		variables.put("CMPROCJ", CMPROCJ);

		if (CMPROCJ.equals("(Vago)") || CMPROCJ.equals("Vago")) {
			expedienteVago = true;
		}

		String CMPROMJ = prefs.getValue("CMPROMJConfig", "");
		variables.put("CMPROMJ", CMPROMJ);

		if (CMPROMJ.equals("(Vago)") || CMPROMJ.equals("Vago")) {
			expedienteVago = true;
		}

		String CSI = prefs.getValue("CSIConfig", "");
		variables.put("CSI", CSI);

		if (CSI.equals("(Vago)") || CSI.equals("Vago")) {
			expedienteVago = true;
		}

		String CEAF = prefs.getValue("CEAFConfig", "");
		variables.put("CEAF", CEAF);

		if (CEAF.equals("(Vago)") || CEAF.equals("Vago")) {
			expedienteVago = true;
		}

		String OUVI = prefs.getValue("OUVIConfig", "");
		variables.put("OUVI", OUVI);

		if (OUVI.equals("(Vago)") || OUVI.equals("Vago")) {
			expedienteVago = true;
		}

		String SGMP = prefs.getValue("SGMPConfig", "");
		variables.put("SGMP", SGMP);

		if (SGMP.equals("(Vago)") || SGMP.equals("Vago")) {
			expedienteVago = true;
		}

		String ARIDP = prefs.getValue("ARIDPConfig", "");
		variables.put("ARIDP", ARIDP);

		if (ARIDP.equals("(Vago)") || ARIDP.equals("Vago")) {
			expedienteVago = true;
		}

		String AAP = prefs.getValue("AAPConfig", "");
		variables.put("AAP", AAP);

		if (AAP.equals("(Vago)") || AAP.equals("Vago")) {
			expedienteVago = true;
		}

		firstPageHeaderPart.variableReplace(variables);
		headerPart.variableReplace(variables);
		mainPart.variableReplace(variables);

		WordprocessingMLPackage firstPagePackage = WordprocessingMLPackage.createPackage();

		boolean firstPage = true;
		List<Lista> listaOls = new ArrayList<Lista>();

		// faz a leitura da listagem de todos os contedos recebidos pelo servio Rest
		for (int i = 0; i < listaConteudos.length(); i++) {

			WordprocessingMLPackage wordCurrentPackage = WordprocessingMLPackage.createPackage();
			JSONObject obj = new JSONObject(listaConteudos.get(i).toString());

			orgao = obj.get("ORGAO").toString();
			orgao = util.tratarString(orgao, "titulo");

			titulo = util.trataNome(listaConteudos, obj.get("NOME").toString());
			titulo = util.tratarString(titulo, "titulo");

			conteudo = obj.get("CONTEUDO").toString();
			idMateria = obj.get("IDMATERIA").toString();

			conteudo = util.tratarString(conteudo, "conteudo");
			conteudo = util.tratarLista(conteudo);

			wordCurrentPackage = util.ConverterHTML(conteudo, orgao, titulo, idMateria, delimitador, actionRequest);

			currentDocumentPart = wordCurrentPackage.getMainDocumentPart();
			acumuladoPackage.getMainDocumentPart().getContent().addAll(currentDocumentPart.getContent());
			wordCurrentPackage = null;
			currentDocumentPart = null;

		}

		MainDocumentPart acumuladoDocumentPart = acumuladoPackage.getMainDocumentPart();

		if (expedienteVago == true) {
			templatePackage = util.tratarExpedienteVago(templatePackage);
		}

		templatePackage.getMainDocumentPart().getContent().addAll(acumuladoDocumentPart.getContent());

		util.ORGAO = "";
		util.TITULO = "";
		String dataNomeArquivo = dataDivulgacao.replace("/", "-");

		String nomeArquivo = "";
		if (delimitador.equals("on")) {
			nomeArquivo = "caderno_doerj_" + dataNomeArquivo + "_materia_delimitada.docx";
		} else {

			nomeArquivo = "caderno_doerj_" + dataNomeArquivo + ".docx";
		}

		// cria o arquivo temporrio que ser utilizado na resposta da requisio
		File exportFile = File.createTempFile("caderno_doerj_tmp_", ".docx");

		try {

			CadernoUtil caderno = new CadernoUtil();
			// System.out.println(XmlUtils.marshaltoString(templatePackage.getMainDocumentPart().getJaxbElement(),
			// true, true));
			templatePackage.save(exportFile);
			PortletResponse pResponse = PortalUtil.getLiferayPortletResponse(actionResponse);
			HttpServletResponse res = PortalUtil.getHttpServletResponse(pResponse);
			res.setHeader("Content-Disposition", "attachment; filename=" + nomeArquivo);//
			res.setContentType(ContentTypes.APPLICATION_MSWORD);

			try (FileInputStream in = new FileInputStream(exportFile);) {
				OutputStream out = res.getOutputStream();

				byte[] buffer = new byte[4096];

				int numBytesRead;

				while ((numBytesRead = in.read(buffer)) > 0) {
					out.write(buffer, 0, numBytesRead);
				}

				out.flush();
				res.flushBuffer();
			}

		} catch (Exception e) {
			e.printStackTrace();
			exportFile.delete();
			CadernoUtil caderno = new CadernoUtil();
			caderno.QTD_LISTAS = 0L;

		} finally {

			exportFile.delete();
			CadernoUtil caderno = new CadernoUtil();
			caderno.QTD_LISTAS = 0L;
		}

	}

}
